SystemOrganization addCategory: #'MC2-Repositories-Tests'!
SystemOrganization addCategory: #'MC2-Repositories-File'!
SystemOrganization addCategory: #'MC2-Repositories-Net'!
SystemOrganization addCategory: #'MC2-Repositories-FileOut'!

MDRepositoryTest subclass: #MDFileRepositoryTest
	instanceVariableNames: 'second'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 12/23/2007 00:06'!
destroyRepository: aRepository named: aString
	aRepository close.
	FileDirectory default deleteFileNamed: (aString, '.mcr')! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 1/1/2007 10:02'!
newRepository
	^ MDFileRepository named: self repositoryFileName! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 1/1/2007 10:02'!
repositoryFileName
	^ 'test-file-repository'! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 12/23/2007 00:10'!
secondFileName
	^ 'test-file-repository2'! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 12/23/2007 00:08'!
secondRepository
	^ second _ MDFileRepository named: self secondFileName! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 12/23/2007 00:09'!
tearDown
	self destroyRepository: repository named: self repositoryFileName.
	second ifNotNil:
		[self destroyRepository: second named: self secondFileName]! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 1/1/2007 10:04'!
testConcurrentAppend
	| version repository2 get |
	[repository2 _ self newRepository.
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
	get _ repository2 get: version hashstamp.
	self assert: get notNil.
	self assert: get isEquivalentTo: version]
		ensure: [repository2 ifNotNil: [repository2 close]]
! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'avi 4/17/2005 01:41'!
testReopen
	| version |
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
	repository _ self newRepository.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
! !

MDRepositoryTest subclass: #MDNetRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:00'!
newRepository
	^ MDFakeLink repositoryForTesting ! !

TestResource subclass: #MDBogusRepositoryResource
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDBogusRepositoryResource class methodsFor: 'as yet unclassified' stamp: 'cwp 4/18/2008 08:06'!
compileContents: aSet
	 | source |
	source := String streamContents:
		[:stream |
		stream 
			nextPutAll: 'contents';
			crtab;
			nextPutAll: '^ MDMarshal materialize: #('.
		(MDMarshal serialize: aSet)
			do: [:b | stream print: b] separatedBy: [stream space].
		stream nextPut: $)].
	
	self compile: source ! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:46'!
contents
	^ MDMarshal materialize: #(17 9 41 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 70 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 16 97 99 99 101 115 115 101 115 67 86 97 114 65 108 115 111 7 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 39 97 99 99 101 115 115 101 115 67 86 97 114 65 108 115 111 13 9 94 32 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 3 111 110 101 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 8 111 110 101 13 9 94 32 49 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 11 14 9 6 66 111 103 117 115 66 15 9 22 102 105 114 115 116 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 12 14 9 6 66 111 103 117 115 66 14 9 19 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 73 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 5 119 111 114 100 115 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 12 97 99 99 101 115 115 101 115 73 118 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 38 97 99 99 101 115 115 101 115 73 118 97 114 13 9 94 32 102 105 114 115 116 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 28 98 111 103 117 115 72 111 112 101 102 117 108 108 121 85 110 105 113 117 101 83 101 108 101 99 116 111 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 6 115 111 117 114 99 101 15 9 59 98 111 103 117 115 72 111 112 101 102 117 108 108 121 85 110 105 113 117 101 83 101 108 101 99 116 111 114 13 9 115 101 108 102 32 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 9 66 111 103 117 115 80 111 111 108 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 11 66 111 103 117 115 45 80 111 111 108 115 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 10 83 104 97 114 101 100 80 111 111 108 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 5 116 104 114 101 101 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 10 116 104 114 101 101 13 9 94 32 51 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 72 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 8 118 97 114 105 97 98 108 101 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 8 105 115 83 116 114 105 110 103 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 6 115 111 117 114 99 101 15 9 17 105 115 83 116 114 105 110 103 13 9 94 32 102 97 108 115 101 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 22 115 101 110 100 115 83 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 115 101 110 100 101 114 115 14 9 6 115 111 117 114 99 101 15 9 46 115 101 110 100 115 83 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 13 9 115 101 108 102 32 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 3 102 111 111 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 11 102 111 111 13 9 94 32 115 101 108 102 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 1 97 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 108 101 116 116 101 114 115 14 9 6 115 111 117 114 99 101 15 9 7 97 13 9 94 32 36 65 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 24 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 6 115 111 117 114 99 101 15 9 32 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 13 9 94 32 115 101 108 102 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 1 98 7 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 8 99 97 112 105 116 97 108 115 14 9 6 115 111 117 114 99 101 15 9 7 98 13 9 94 32 36 66 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 17 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 115 101 110 100 101 114 115 14 9 6 115 111 117 114 99 101 15 9 36 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 13 9 115 101 108 102 32 97 99 99 101 115 115 101 115 73 118 97 114 18 9 0 23 5 9 5 21 52 210 77 14 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 65 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 14 1 5 9 2 1 5 9 1 22 52 210 74 181 136 214 8 28 229 10 135 154 71 235 31 140 225 52 243 176 232 228 241 65 20 9 2 14 9 4 110 97 109 101 15 9 5 66 111 103 117 115 14 9 4 116 121 112 101 14 9 7 80 97 99 107 97 103 101 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 67 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 10 14 9 6 66 111 103 117 115 65 20 9 3 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 4 116 101 120 116 15 9 18 67 111 109 109 101 110 116 32 102 111 114 32 66 111 103 117 115 65 14 9 9 116 105 109 101 83 116 97 109 112 21 45 155 232 228 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 4 102 105 118 101 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 29 102 105 118 101 13 9 94 32 115 101 108 102 32 116 119 111 32 43 32 115 101 108 102 32 116 104 114 101 101 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 1 97 7 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 8 99 97 112 105 116 97 108 115 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 7 97 13 9 94 32 36 66 14 9 9 116 105 109 101 83 116 97 109 112 21 49 17 69 60 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 13 14 9 6 66 111 103 117 115 66 15 9 28 115 101 99 111 110 100 67 108 97 115 115 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 2 14 9 19 77 68 80 111 111 108 73 109 112 111 114 116 69 108 101 109 101 110 116 9 1 15 9 8 112 111 111 108 78 97 109 101 14 9 6 66 111 103 117 115 66 14 9 9 66 111 103 117 115 80 111 111 108 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 12 97 99 99 101 115 115 101 115 67 86 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 35 97 99 99 101 115 115 101 115 67 86 97 114 13 9 94 32 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 19 98 111 103 117 115 85 110 115 101 110 116 83 101 108 101 99 116 111 114 8 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 27 98 111 103 117 115 85 110 115 101 110 116 83 101 108 101 99 116 111 114 13 9 94 32 115 101 108 102 14 9 9 116 105 109 101 83 116 97 109 112 21 50 96 25 84 18 9 0 23 5 9 6 21 52 236 135 53 18 9 39 22 52 210 77 14 230 14 192 54 98 221 42 167 89 55 169 18 137 133 222 252 161 43 98 177 22 52 210 77 14 240 206 23 234 227 147 202 240 30 206 111 181 227 145 175 49 39 93 243 56 22 52 210 77 15 20 227 18 179 32 168 73 170 59 92 54 8 24 89 91 94 176 242 172 179 22 52 210 77 15 26 101 74 226 31 99 226 180 200 119 141 89 161 7 227 96 159 171 66 190 22 52 210 77 15 34 53 212 217 190 138 204 223 250 252 189 7 138 72 243 5 21 237 162 237 22 52 210 77 15 40 180 121 103 245 73 228 7 11 88 86 111 179 156 101 120 176 127 51 160 22 52 210 77 15 53 177 235 187 168 126 208 124 26 58 110 175 17 169 39 14 162 81 52 15 22 52 210 77 15 54 6 90 172 178 254 141 74 197 32 144 204 200 171 94 121 212 96 4 234 22 52 210 77 15 55 59 117 228 124 154 167 250 249 216 182 74 169 28 9 35 81 11 25 149 22 52 210 77 15 59 96 179 118 221 60 225 220 184 49 58 116 78 124 251 203 100 139 109 91 22 52 210 77 15 69 29 62 109 2 230 96 137 153 114 221 155 98 252 189 79 52 129 160 190 22 52 210 77 15 75 36 105 163 106 127 221 157 106 198 49 201 198 129 74 76 143 107 41 30 22 52 210 77 15 75 222 179 162 193 178 106 137 175 74 127 137 48 81 111 44 191 153 226 34 22 52 210 77 15 76 92 146 169 243 29 85 139 65 32 16 152 75 247 38 148 82 131 202 182 22 52 210 77 15 77 40 46 148 145 113 48 18 32 143 248 3 81 175 11 111 146 189 224 197 22 52 210 77 15 91 110 45 164 247 88 92 113 27 242 220 243 51 0 97 114 163 186 65 30 22 52 210 77 15 95 120 28 4 255 206 94 42 72 84 23 25 198 224 182 222 175 157 114 122 22 52 210 77 15 106 141 31 91 50 122 35 22 226 32 169 70 107 139 112 201 181 199 25 185 22 52 210 77 15 113 208 100 189 96 7 132 77 251 49 221 61 9 157 68 65 98 13 116 179 22 52 210 77 15 126 154 11 79 117 121 136 127 197 122 206 55 110 180 226 45 105 170 76 213 22 52 210 77 15 145 225 239 49 134 205 3 167 228 57 105 203 156 87 44 67 56 26 217 102 22 52 210 77 15 146 190 92 159 75 202 17 81 93 50 210 112 74 109 41 62 12 232 91 204 22 52 210 77 15 147 152 52 232 62 169 227 6 22 62 219 230 246 149 90 10 114 32 105 239 22 52 210 77 15 153 133 54 195 220 161 247 94 95 65 246 188 229 217 111 118 64 195 152 19 22 52 210 77 15 156 61 130 18 165 74 205 194 171 45 14 47 150 106 112 60 12 102 96 48 22 52 210 77 15 156 230 26 244 188 62 202 158 247 25 231 63 8 40 121 116 55 126 150 176 22 52 210 77 15 167 246 225 38 91 196 116 92 109 191 167 39 156 126 238 244 199 120 102 95 22 52 210 77 15 197 195 43 232 22 50 123 224 245 26 15 16 141 187 79 155 117 152 199 192 22 52 210 77 15 209 212 166 207 144 135 255 12 9 144 247 117 142 63 238 33 152 65 136 180 22 52 210 77 15 213 129 168 147 108 17 202 158 102 236 24 60 198 65 118 165 78 250 245 238 22 52 210 77 15 217 213 27 99 200 84 155 183 165 224 0 102 50 104 28 60 11 52 111 29 22 52 210 77 15 225 235 200 182 46 255 94 192 210 126 206 140 236 251 64 172 10 177 75 240 22 52 210 77 15 227 134 126 137 114 67 191 74 119 174 92 48 210 21 245 254 143 62 105 40 22 52 210 77 15 237 23 253 162 29 138 89 188 76 225 250 129 184 197 81 165 91 236 180 253 22 52 210 77 15 239 226 30 61 58 49 122 92 208 255 228 124 124 29 36 210 199 17 244 93 22 52 210 77 15 241 4 93 97 162 50 33 36 250 229 93 95 47 133 81 84 195 195 121 215 22 52 210 77 15 247 220 65 63 123 137 22 208 226 31 103 79 200 179 225 45 101 40 20 74 22 52 210 77 15 254 161 194 7 192 129 121 46 119 136 201 57 157 40 135 221 103 193 39 179 22 52 210 77 15 255 209 8 238 70 151 123 91 125 139 200 199 112 219 249 126 133 71 140 52 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 11 14 9 6 66 111 103 117 115 66 15 9 23 115 101 99 111 110 100 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 13 14 9 6 66 111 103 117 115 66 15 9 27 102 105 114 115 116 67 108 97 115 115 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 74 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 4 119 101 97 107 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 7 21 52 210 76 249 22 52 236 135 53 144 161 138 88 33 78 6 59 212 18 216 31 230 25 180 151 160 147 77 246 17 9 0 20 9 5 14 9 6 97 117 116 104 111 114 15 9 33 67 111 108 105 110 32 80 117 116 110 101 121 32 60 99 112 117 116 110 101 121 64 119 105 114 101 111 110 103 46 99 97 62 14 9 7 99 111 109 109 101 110 116 15 9 21 83 110 97 112 115 104 111 116 32 102 111 114 32 116 101 115 116 105 110 103 46 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 7 111 114 100 105 110 97 108 9 1 14 9 9 115 108 105 99 101 78 97 109 101 15 9 5 66 111 103 117 115 22 52 210 74 181 136 214 8 28 229 10 135 154 71 235 31 140 225 52 243 176 232 228 241 65 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 12 14 9 6 66 111 103 117 115 66 14 9 20 83 101 99 111 110 100 67 108 97 115 115 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 69 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 66 111 103 117 115 65 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 67 14 9 12 104 97 115 84 105 109 101 115 116 97 109 112 8 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 7 116 101 115 116 105 110 103 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 20 104 97 115 84 105 109 101 115 116 97 109 112 13 9 94 32 116 114 117 101 14 9 9 116 105 109 101 83 116 97 109 112 21 45 159 254 52 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 66 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 3 116 119 111 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 8 116 119 111 13 9 94 32 50 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 71 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 5 98 121 116 101 115 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 1 98 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 108 101 116 116 101 114 115 14 9 6 115 111 117 114 99 101 15 9 7 98 13 9 94 32 36 66 18 9 0 23 5 9 5 21 52 210 77 15 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 65 14 9 19 105 115 67 111 109 112 108 101 116 101 108 121 85 115 101 108 101 115 115 7 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 7 116 101 115 116 105 110 103 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 27 105 115 67 111 109 112 108 101 116 101 108 121 85 115 101 108 101 115 115 13 9 94 32 116 114 117 101 14 9 9 116 105 109 101 83 116 97 109 112 21 49 17 70 104 18 9 0)! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:34'!
fileout
	| out exporter memo |
	out := WriteStream on: String new.
	exporter := MDFileOutExporter on: out.
	memo := repository memos anyOne.
	exporter export: memo from: repository.
	^ out contents

! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 3/23/2008 23:48'!
repository
	^ repository! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 23:57'!
setUp
	
	repository _ MDMemoryRepository new.
	repository putAll: self contents! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 3/23/2008 23:48'!
tearDown
	repository _ nil! !

Object subclass: #MDByteIndex
	instanceVariableNames: 'keySize valueSize streamSize stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2005 03:08'!
stream: aStream keySize: keyNumber valueSize: valueNumber
	^ self stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: aStream size! !

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/19/2005 02:41'!
stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	^ self basicNew setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray
	^ self at: keyArray ifAbsent: [self error: 'Could not find key ', keyArray printString]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray ifAbsent: errorBlock
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	^ self basicAt: keyArray ifAbsent: errorBlock! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:37'!
at: keyArray put: valueArray
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	valueArray size = valueSize ifFalse: [self error: 'Value must be exactly ', valueSize asString, ' bytes'].
	^ self basicAt: keyArray put: valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:34'!
basicAt: keyArray ifAbsent: errorBlock
	| i key |
	i _ self scanFor: keyArray.
	key _ self keyBytesAtIndex: i.
	^ key = keyArray
		ifTrue: [self valueBytesAtIndex: i]
		ifFalse: errorBlock! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
basicAt: keyArray put: valueArray
	| i key |
	i _ self scanFor: keyArray.
	key _ self keyBytesAtIndex: i.
	key = keyArray ifFalse:
		[self writeTally: self tally + 1.
		self writeKeyBytes: keyArray atIndex: i].
	self writeValueBytes: valueArray atIndex: i.
	^ valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:45'!
hash: keyArray
	^ keyArray hash! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:38'!
keyBytesAtIndex: i
	self seekTo: i.
	^ stream atEnd
		ifTrue: [ByteArray new: keySize]
		ifFalse: [stream next: keySize]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
keySize
	^ keySize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:07'!
maxIndex
	^ streamSize - 4 // self recordSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:43'!
recordSize
	^ keySize + valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:33'!
scanFor: keyArray
	| start |
	start _ (self hash: keyArray) \\ self maxIndex.
	start to: self maxIndex do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	0 to: start - 1 do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	
	self error: 'Index is full'! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:29'!
scanFor: keyArray at: i
	| key |
	key _ self keyBytesAtIndex: i.
	^ key = keyArray or: [key allSatisfy: [:b | b = 0]]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
seekTo: i
	stream position: i * self recordSize + 4! !

!MDByteIndex methodsFor: 'initialize-release' stamp: 'avi 3/19/2005 02:41'!
setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	keySize _ keyNumber.
	valueSize _ valueNumber.
	streamSize _ streamNumber.
	stream _ aStream.
	stream binary! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/19/2005 02:51'!
streamSize
	^ streamSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/15/2005 03:23'!
tally
	stream reset.
	^ stream atEnd
		ifTrue: [0]
		ifFalse: [stream nextInt32]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:41'!
valueBytesAtIndex: i
	self seekTo: i.
	stream skip: keySize.
	^ stream next: valueSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
valueSize
	^ valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeKeyBytes: keyBytes atIndex: i
	self seekTo: i.
	stream nextPutAll: keyBytes! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
writeTally: aNumber
	stream reset.
	stream nextInt32Put: aNumber! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeValueBytes: valueBytes atIndex: i
	self seekTo: i.
	stream skip: keySize.
	stream nextPutAll: valueBytes! !

Object subclass: #MDChunk
	instanceVariableNames: 'element properties invisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 22:21'!
forElement: anElement
	^ self new setElement: anElement! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:29'!
beInvisible
	invisible := true! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:29'!
isRemoval
	^ properties isNil! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/27/2008 00:06'!
load: aPropertyDictionary
	properties := aPropertyDictionary.
	! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/26/2008 23:50'!
reactToClass: aChunk
	(element theClassName = aChunk name and: [aChunk isRemoval])
		ifTrue: [self beInvisible].
	^ aChunk! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/27/2008 00:05'!
remove
	properties := nil! !

!MDChunk methodsFor: 'initialize-release' stamp: 'cwp 4/27/2008 00:29'!
setElement: anElement
	invisible := false.
	element := anElement.! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 3/30/2008 23:47'!
sortKey
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: element theClassName;
			nextPut: $!!;
			nextPut: self typeChar;
			nextPut: $!!;
			nextPutAll: element name]! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 4/27/2008 00:31'!
writeOn: aStream
	invisible ifFalse:
		[properties
			ifNil: [self writeRemovalOn: aStream]
			ifNotNil: [self writeDefinitionOn: aStream]]! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 4/2/2008 00:19'!
writeStampOn: aStream 
	((properties includesKey: #initials) and: [ properties includesKey: #timestamp ]) ifTrue: 
		[ aStream
			nextPutAll: ''' stamp: ''';
			nextPutAll: properties initials;
			space.
		properties timestamp printer 
			printOn: aStream
			format: '%l/%e/%Y %H:%M' ]! !

MDChunk subclass: #MDClassChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 00:19'!
forElement: anElement
	^ self new setElement: anElement! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:11'!
formatKeyword
	| format |
	format _ properties format.
	format = #normal ifTrue: [^ 'subclass:'].
	format = #bytes ifTrue: [^ 'variableByteSubclass:'].
	format = #variable ifTrue: [^ 'variableSubclass:'].
	format = #words ifTrue: [^ 'variableWordSubclass:'].
	format = #weak ifTrue: [^ 'weakSubclass:'].
	self error: 'Unrecognized format'! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 4/26/2008 20:33'!
name
	^ element theClassName! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 4/26/2008 20:32'!
reactToClass: aSymbol
	^ self! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $a! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:17'!
writeDefinitionOn: aStream
	aStream 
		nextPutAll: properties superclassName;
		space;
		nextPutAll: self formatKeyword;
		space;
		print: element theClassName;
		crtab;
		nextPutAll: 'instanceVariableNames: ''''';
		crtab;
		nextPutAll: 'classVariableNames: ''''';
		crtab;
		nextPutAll: 'poolDictionaries: ''''';
		crtab;
		nextPutAll: 'category: ';
		nextPut: $';
		nextPutAll: properties category;
		nextPut: $';
		nextPut: $!!;
		cr! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:18'!
writeRemovalOn: aStream
	aStream 
		nextPutAll: 'Smalltalk removeClassNamed: #';
		nextPutAll: element theClassName;
		nextPut: $!!;
		cr! !

MDChunk subclass: #MDClassCommentChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $b! !

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:59'!
writeDefinitionOn: aStream
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName;
		nextPutAll: ' commentStamp: ''';
		nextPutAll: (properties initials ifNil: ['<unknown author>']);
		space.
	properties timeStamp printer printOn: aStream format: '%l/%e/%Y %H:%M'.
	aStream
		nextPutAll: ''' prior: 0!!';
		cr.
	properties text do:
		[:ch |
		aStream nextPut: ch.
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPut: $!!;
		cr! !

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 23:37'!
writeRemovalOn: aStream
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName;
		nextPutAll: ' classComment: nil stamp: nil!!';
		cr! !

MDChunk subclass: #MDMethodChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:55'!
typeChar
	^ element classIsMeta
		ifTrue: [$h]
		ifFalse: [$f]! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:08'!
writeDefinitionOn: aStream 
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName.
	element classIsMeta ifTrue: [ aStream nextPutAll: ' class' ].
	aStream
		space;
		nextPutAll: 'methodsFor: ''';
		nextPutAll: properties category.
	self writeStampOn: aStream.
	aStream
		nextPutAll: '''!!';
		cr.
	properties source do:
		[:ch |
		aStream nextPut: ch.
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPutAll: '!! !!';
		cr! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:03'!
writeRemovalOn: aStream
	aStream nextPutAll: element theClassName.
	element classIsMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream 
		nextPutAll: ' removeSelector: #';
		nextPutAll: element selector;
		nextPut: $!!;
		cr! !

MDChunk subclass: #MDNullChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDNullChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:39'!
sortKey
	^ ''! !

!MDNullChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 00:10'!
writeOn: aStream! !

MDChunk subclass: #MDVariableChunk
	instanceVariableNames: 'independent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

MDVariableChunk subclass: #MDClassInstVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:20'!
classReference
	^ element theClassName, ' class'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:29'!
definitionSelector
	^ 'class addInstVarName:'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:15'!
listSelector
	^ 'instVarNames'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:35'!
removalSelector
	^ 'class removeInstVarName:'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:52'!
typeChar
	^ $g! !

MDVariableChunk subclass: #MDClassVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:14'!
definitionSelector
	^ 'addClassVarName:'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:21'!
listSelector
	^ 'classVarNames'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:15'!
removalSelector
	^ 'removeClassVarName:'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:51'!
typeChar
	^ $d! !

MDVariableChunk subclass: #MDInstVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:15'!
definitionSelector
	^ 'addInstVarName:'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:22'!
listSelector
	^ 'instVarNames'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:16'!
removalSelector
	^ 'removeInstVarName:'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $c! !

MDVariableChunk subclass: #MDPoolImportChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:48'!
definitionSelector
	^ 'addSharedPool:'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:48'!
listSelector
	^ 'sharedPools'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:55'!
quote
	^ ''! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:28'!
removalSelector
	^ 'removeSharedPool:'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:52'!
typeChar
	^ $e! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/3/2008 22:26'!
beDependent
	independent := false! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/3/2008 22:26'!
beIndependent
	independent := true! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:31'!
classReference
	^ element theClassName! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
conditional
	^ properties
		ifNil: ['ifTrue:']
		ifNotNil: ['ifFalse:']! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
definitionSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
listSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
quote
	^ ''''! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:40'!
reactToClass: aChunk
	element theClassName = aChunk name ifTrue: 
		[aChunk isRemoval
			ifTrue: [self beInvisible]
			ifFalse: [self beDependent]].
	^ aChunk! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
removalSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'initialize-release' stamp: 'cwp 4/3/2008 22:28'!
setElement: anElement
	super setElement: anElement.
	independent := true! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
typeChar
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeBasicDefinitionOn: aStream 
	aStream
		nextPutAll: element theClassName;
		space;
		nextPutAll: self definitionSelector;
		space;
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeBasicRemovalOn: aStream 
	aStream
		nextPutAll: element theClassName;
		space;
		nextPutAll: self removalSelector;
		space;
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeClassCheckOn: aStream with: aBlock
	independent ifFalse: aBlock ifTrue: 
		[aStream
			nextPutAll: '(Smalltalk hasClassNamed: #';
			nextPutAll: element theClassName;
			nextPutAll: ') ifTrue:';
			crtab;
			nextPut: $[.
		aBlock value.
		aStream
			nextPut: $]].
	aStream 
		nextPut: $!!; 
		cr! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeDefinitionOn: aStream 
	self 
		writeClassCheckOn: aStream
		with: 
			[ self 
				writeGuardOn: aStream
				with: [ self writeBasicDefinitionOn: aStream ] ]! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeGuardOn: aStream with: aBlock
	aStream
		nextPut: $(;
		nextPutAll: self classReference;
		space;
		nextPutAll: self listSelector;
		nextPutAll: ' includes: ';
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote;
		nextPutAll: ') ';
		nextPutAll: self conditional;
		crtab.
	independent ifTrue: [aStream tab].
	aStream nextPut: $[.
	aBlock value.
	aStream nextPut: $]! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:29'!
writeRemovalOn: aStream 
	self 
		writeClassCheckOn: aStream
		with: 
			[ self 
				writeGuardOn: aStream
				with: [ self writeBasicRemovalOn: aStream ] ]! !

Object subclass: #MDFakeLink
	instanceVariableNames: 'service'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFakeLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/5/2008 00:09'!
repositoryForTesting
	| service link repository |
	service _ MDNetService for: MDMemoryRepository new.
	link _ MDFakeLink to: service.
	repository _ MDNetRepository link: link.
	^ repository! !

!MDFakeLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 23:58'!
to: aService
	^ self new setService: aService! !

!MDFakeLink methodsFor: 'accessing' stamp: 'cwp 1/5/2008 00:10'!
description
	^ 'fake net repository'! !

!MDFakeLink methodsFor: 'testing' stamp: 'cwp 1/5/2008 00:04'!
isOpen
	^ true! !

!MDFakeLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 23:58'!
send: aMessage
	^ service handleMessage: aMessage! !

!MDFakeLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 23:58'!
setService: aService
	service _ aService! !

Object subclass: #MDFakeLocator
	instanceVariableNames: 'stream mocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:38'!
createStream
	| class |
	class _ Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream].
	stream _ class on: self mocket.
	^ stream! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:03'!
description
	^ 'Fake'! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 16:02'!
mocket
	
	^ mocket ifNil: 
		[mocket _ MLMocket new.
		mocket
			execute: [mocket connectTo: #(127 0 0 1) port: 7301];
			expectConnectionTo: #(127 0 0 1) port: 7301]! !

Object subclass: #MDFileOutExporter
	instanceVariableNames: 'stream chunks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDFileOutExporter class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:16'!
on: aStream
	^ self new setStream: aStream! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/25/2008 22:21'!
adaptorForClassCommentElement: anElement
	^ chunks add: (MDClassCommentChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/25/2008 00:19'!
adaptorForClassElement: anElement
	^ chunks add: (MDClassChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 4/2/2008 00:02'!
adaptorForClassInstVarElement: anElement 
	^ chunks add: (MDClassInstVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/27/2008 21:18'!
adaptorForClassVarElement: anElement 
	^ chunks add: (MDClassVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/27/2008 21:08'!
adaptorForInstVarElement: anElement 
	^ chunks add: (MDInstVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/27/2008 21:54'!
adaptorForMethodElement: anElement 
	^ chunks add: (MDMethodChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/27/2008 23:04'!
adaptorForPoolImportElement: anElement 
	^ chunks add: (MDPoolImportChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 3/30/2008 00:19'!
adaptorForSliceElement: aSliceElement 
	^ MDNullChunk new! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 3/25/2008 00:17'!
add: aVersion
	aVersion variant loadInto: self! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 3/24/2008 23:16'!
addMemo: aMemo
	chunks add: (MDMemoChunk on: aMemo)! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 3/30/2008 22:58'!
export: aMemo from: aRepository
	| snapshot |
	self addMemo: aMemo.
	snapshot := aRepository get: aMemo reference.
	snapshot contents do:
		[:ea | self add: (aRepository get: ea)].
	self harmonize.
	self flush! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 3/30/2008 23:23'!
flush
	chunks 
		do: [:ea | ea writeOn: stream]
		separatedBy: [stream cr].
	stream flush! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 4/26/2008 20:31'!
harmonize
	| class |
	chunks := chunks asSortedCollection: [ :a :b | a sortKey <= b sortKey ].
	class := nil.
	chunks do: [ :chunk | class := chunk reactToClass: class ]! !

!MDFileOutExporter methodsFor: 'initialize-release' stamp: 'cwp 3/30/2008 00:22'!
setStream: aStream
	stream _ aStream.
	chunks _ OrderedCollection new! !

Object subclass: #MDKeyedStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDKeyedStream class methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:19'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
= other
	^ self species = other species
		and: [self stream name = other stream name]! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 11/6/2007 22:52'!
appendKey: keyBytes value: valueBytes 
	self assert: [keyBytes size = self keySize].
	stream
		setToEnd;
		nextPutAll: keyBytes;
		nextInt32Put: valueBytes size;
		nextPutAll: valueBytes! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 10/13/2005 23:00'!
close
	stream name = 'a stream' ifFalse: [stream close]! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
flush
	stream flush! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/19/2005 01:49'!
fromPosition: aNumber keysValuesAndPositionsDo: aBlock 
	| position key |
	stream position: aNumber.
	[stream atEnd] whileFalse: 
			[key := stream next: self keySize.
			position := stream position.
			aBlock
				value: key
				value: self readValue
				value: position]! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ self stream name hash! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 4/17/2005 01:19'!
initializeWithStream: aPositionableStream
	stream _ aPositionableStream.
	stream binary! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 15:14'!
keySize
	^ 24! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 02:11'!
keysValuesAndPositionsDo: aBlock 
	self fromPosition: 0 keysValuesAndPositionsDo: aBlock
			! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:38'!
nextValuePosition
	^ stream size + self keySize! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 4/10/2005 17:29'!
position
	^ stream position! !

!MDKeyedStream methodsFor: 'private' stamp: 'avi 4/17/2005 01:29'!
readValue
	| length |
	length := stream nextInt32.
	^ stream next: length.
	! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 3/22/2006 19:23'!
reopen
	stream name = 'a stream' ifFalse: [stream reopen; binary]! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 14:53'!
stream
	^ stream! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:28'!
valueAtPosition: anInteger
	stream position: anInteger.
	^ self readValue! !

Object subclass: #MDMemoChunk
	instanceVariableNames: 'memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDMemoChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
on: aMemo
	^ self new setMemo: aMemo! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:15'!
reactToClass: aChunk
	^ aChunk! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
setMemo: aMemo
	memo _ aMemo! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:40'!
sortKey
	^ ''! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:00'!
writeOn: aStream
	aStream 
		nextPut: $";
		nextPutAll: memo name;
		cr.
	memo description do:
		[:ch | 
		aStream nextPut: ch. 
		ch = $" ifTrue: [aStream nextPut: $"].
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPutAll: '"!!';
		cr! !

Object subclass: #MDMockLink
	instanceVariableNames: 'injected expected open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDMockLink methodsFor: 'asserting' stamp: 'cwp 1/4/2008 12:32'!
assert: actual matches: expectation
	actual = expectation ifFalse: [TestFailure signal: 'Unexpected message']! !

!MDMockLink methodsFor: 'open/close' stamp: 'cwp 1/4/2008 12:47'!
close
	open _ false! !

!MDMockLink methodsFor: 'accessing' stamp: 'cwp 1/4/2008 14:19'!
description
	^ 'Mock'! !

!MDMockLink methodsFor: 'asserting' stamp: 'cwp 1/4/2008 12:26'!
expect: aMessage
	expected add: aMessage! !

!MDMockLink methodsFor: 'initialize-release' stamp: 'cwp 1/4/2008 12:33'!
initialize
	injected _ OrderedCollection new.
	expected _ OrderedCollection new.
	open _ false! !

!MDMockLink methodsFor: 'asserting' stamp: 'cwp 1/4/2008 12:25'!
inject: aMessage
	injected add: aMessage! !

!MDMockLink methodsFor: 'open/close' stamp: 'cwp 1/4/2008 12:33'!
isOpen
	^ open! !

!MDMockLink methodsFor: 'open/close' stamp: 'cwp 1/4/2008 12:33'!
open
	open _ true! !

!MDMockLink methodsFor: 'sending' stamp: 'cwp 1/4/2008 12:31'!
send: aMessage
	self assert: aMessage matches: expected removeFirst.
	^ injected removeFirst! !

Object subclass: #MDNetLink
	instanceVariableNames: 'locator stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self locator: (MDNetLocator host: aString)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:40'!
host: aString port: anInteger
	^ self locator: (MDNetLocator host: aString port: anInteger)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 14:49'!
locator: aLocator
	^ self new setLocator: aLocator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 12:38'!
close
	stream close.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:04'!
description
	^ locator description! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:10'!
isOpen
	^ stream notNil and: [stream isConnected]! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 16:03'!
locator
	^ locator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 14:32'!
open
	stream _ locator createStream.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:44'!
send: aMessage
	self isOpen ifFalse: [self error: 'Link is not open'].
	aMessage writeOn: stream.
	stream flush.
	^ MDNetMessage readFrom: stream! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 14:49'!
setLocator: aLocator
	locator _ aLocator! !

Object subclass: #MDNetListener
	instanceVariableNames: 'repository port socket process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetListener class methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 00:31'!
repository: aRepository startOn: anInteger
	| listener |
	listener _ self new setRepository: aRepository port: anInteger.
	listener start.
	^ listener! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:23'!
name
	^ '[', repository description, ']'! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:31'!
run
	| connection |
	[socket isValid] whileTrue:
		[connection _ socket waitForAcceptFor: 10 ifTimedOut: [nil].
		connection ifNotNil: [MDServerLink 
								serve: connection 
								repository: repository]]
			! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 22:21'!
setRepository: aRepository port: anInteger
	repository _ aRepository.
	port _ anInteger.
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:22'!
start
	socket _ Socket newTCP.
	socket listenOn: port backlogSize: 10.
	process _ [self run] 
				forkAt: Processor systemBackgroundPriority  
				named: self name
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:09'!
stop
	socket closeAndDestroy! !

Object subclass: #MDNetLocator
	instanceVariableNames: 'host port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:31'!
host: aString 
	^ self host: aString port: nil! !

!MDNetLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:29'!
host: aString port: anInteger
	^ self new setHost: aString port: anInteger! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:12'!
createStream
	| class stream |
	class _ Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream].
	stream _ class openConnectionToHostNamed: self host port: self port.
	stream binary.
	^ stream! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
defaultPort
	^ 6101! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
description
	^ String streamContents: 
		[:stream |
		stream nextPutAll: host.
		port ifNotNil:
			[stream 
				nextPut: $:; 
				print: port]]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
host
	^ host! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
port
	^ port ifNil: [self defaultPort]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:30'!
setHost: aString port: anInteger
	host _ aString.
	port _ anInteger! !

Object subclass: #MDNetMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDNetMessage subclass: #MDEmptyMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDEmptyMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:05'!
readContentsFrom: aStream
	^ self new! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
= other
	^ self species = other species! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
hash
	^ self species hash! !

MDEmptyMessage subclass: #MDGetHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGetHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:02'!
id
	^ 68! !

!MDGetHashstamps methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:42'!
handledBy: anObject
	^ anObject handleGetHashstamps: self! !

MDEmptyMessage subclass: #MDGetMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGetMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 67! !

!MDGetMemos methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:11'!
handledBy: anObject
	^ anObject handleGetMemos: self! !

MDNetMessage subclass: #MDErrorMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDErrorMessage subclass: #MDAuthenticationFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDAuthenticationFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:30'!
id
	^ 193! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:26'!
= other
	^ self species = other species and: [self description = other description]! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	MDPeerError signal: description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:29'!
description
	^ description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
hash
	^ description hash! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ true! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
setContents: aString
	description _ aString! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:28'!
writeContentsOn: aStream
	MDMarshal serialize: description on: aStream! !

MDErrorMessage subclass: #MDObjectNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDObjectNotFound class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 195! !

MDErrorMessage subclass: #MDProcessingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDErrorMessage subclass: #MDStorageFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDStorageFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 196! !

MDErrorMessage subclass: #MDUnauthorized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDUnauthorized class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:32'!
id
	^ 194! !

MDErrorMessage subclass: #MDUnrecognizedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDUnrecognizedMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
id
	^ 192! !

MDNetMessage subclass: #MDHashstampMessage
	instanceVariableNames: 'hashstamps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDHashstampMessage subclass: #MDAllHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDAllHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:36'!
id
	^ 132! !

MDHashstampMessage subclass: #MDGetObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGetObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 64! !

!MDGetObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:28'!
handledBy: aService
	^ aService handleGet: self! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
= other
	^ self species = other species and: [self hashstamps = other hashstamps]! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
hash
	^ hashstamps hash! !

!MDHashstampMessage methodsFor: 'accessing' stamp: 'cwp 1/4/2008 00:02'!
hashstamps
	^ hashstamps! !

!MDHashstampMessage methodsFor: 'intialize-release' stamp: 'cwp 1/4/2008 00:02'!
setContents: aCollection
	hashstamps _ aCollection asSet! !

!MDHashstampMessage methodsFor: 'writing' stamp: 'cwp 1/4/2008 00:02'!
writeContentsOn: aStream
	MDMarshal serialize: hashstamps on: aStream! !

MDHashstampMessage subclass: #MDOfferObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 65! !

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:14'!
withObjects: aCollection
	^ self with: (aCollection collect: [:ea | ea hashstamp])! !

!MDOfferObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:19'!
handledBy: anObject
	^ anObject handleOfferObjects: self! !

MDHashstampMessage subclass: #MDRequestObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDRequestObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 129! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:32'!
filter: aCollection in: aBlock
	| selected |
	selected _ aCollection select: [:ea | hashstamps includes: ea hashstamp].
	selected isEmpty ifFalse: [aBlock value: (MDPutObjects with: selected)]! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:00'!
isRequestObjects
	^ true! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:04'!
fromBytes: aByteArray
	^ self readFrom: aByteArray readStream! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:15'!
id
	self subclassResponsibility! !

!MDNetMessage class methodsFor: 'testing' stamp: 'cwp 1/4/2008 00:17'!
isConcrete
	^ self class includesSelector: #id! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/4/2008 00:17'!
messageClassWithId: anInteger
	^ self allSubclasses 
		detect: [:ea | ea isConcrete and: [ea id = anInteger]]
		ifNone: [self messageIdNotFound: anInteger]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:58'!
messageClasses
	^ self allSubclasses select: [:ea | ea class includesSelector: #id]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:12'!
messageIdNotFound: id
	^ self error: 'Message ', id asString, ' not understood'! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:27'!
readContentsFrom: aStream
	^ self with: (MDMarshal materializeFrom: aStream)! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/4/2008 00:00'!
readFrom: aStream
	| class |
	class _ self messageClassWithId: aStream next.
	^ class readContentsFrom: aStream! !

!MDNetMessage class methodsFor: 'instance creation' stamp: 'cwp 1/3/2008 23:23'!
with: aSet
	^ self new setContents: aSet! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:06'!
assertMessageIs: aClass
	(self isKindOf: aClass) ifFalse: [MDProtocolError signal]! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:05'!
bytes
	^ ByteArray streamContents: [:stream | self writeOn: stream]! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	! !

!MDNetMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:15'!
id
	^ self class id! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:01'!
isRequestObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 20:57'!
isThankYou
	^ false! !

!MDNetMessage methodsFor: 'intialize-release' stamp: 'cwp 1/3/2008 23:23'!
setContents: anObject
	self subclassResponsibility! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:32'!
writeContentsOn: aStream
	! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeOn: aStream
	aStream nextPut: self id.
	self writeContentsOn: aStream! !

MDNetMessage subclass: #MDObjectsMessage
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDObjectsMessage subclass: #MDMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 131! !

!MDMemos methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ true! !

MDObjectsMessage subclass: #MDObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 128! !

!MDObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ true! !

!MDObjectsMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/3/2008 23:14'!
readContentsFrom: aStream
	^ self with: (MDMarshal materializeFrom: aStream)! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
= other
	^ self species = other species
		and: [objects = other objects]! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
hash
	^ objects hash! !

!MDObjectsMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:17'!
objects
	^ objects! !

!MDObjectsMessage methodsFor: 'initialize-release' stamp: 'cwp 1/3/2008 23:29'!
setContents: aCollection
	objects _ aCollection asSet! !

!MDObjectsMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeContentsOn: aStream
	MDMarshal serialize: objects on: aStream! !

MDObjectsMessage subclass: #MDPutObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDPutObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 66! !

!MDPutObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:16'!
handledBy: anObject
	^ anObject handlePutObjects: self! !

MDNetMessage subclass: #MDSalutationMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDSalutationMessage subclass: #MDGoodbye
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGoodbye class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:40'!
id
	^ 2! !

!MDGoodbye methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:25'!
handledBy: anObject
	^ anObject handleGoodbye: anObject! !

!MDGoodbye methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ true! !

MDSalutationMessage subclass: #MDHello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDHello class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
id
	^ 1! !

!MDHello methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:08'!
handledBy: anObject
	^ anObject handleHello: self! !

!MDHello methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ true! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
= other
	^ self species = other species and: [self description = other description]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:32'!
defaultDescription
	^ NetNameResolver localHostName! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:30'!
description
	^ description ifNil: [self defaultDescription]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
hash
	^ description hash! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:38'!
setContents: aString
	description _ aString! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:29'!
writeContentsOn: aStream
	MDMarshal serialize: self description on: aStream! !

MDNetMessage subclass: #MDThankYou
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDThankYou class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 130! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
= other
	^ self species = other species and: [self count = other count]! !

!MDThankYou methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:52'!
count
	^ count! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
hash
	^ count hash! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/4/2008 20:58'!
isThankYou
	^ true! !

!MDThankYou methodsFor: 'intialize-release' stamp: 'cwp 1/3/2008 23:50'!
setContents: anInteger
	count _ anInteger! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:51'!
writeContentsOn: aStream
	MDMarshal serialize: count on: aStream! !

Object subclass: #MDNetService
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetService class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:22'!
for: aRepository
	^ self new setRepository: aRepository! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/19/2008 01:32'!
description
	^ repository description! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 21:27'!
handleGet: message
	^ MDObjects with: (repository getAll: message hashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/8/2008 18:43'!
handleGetHashstamps: message
	^ MDAllHashstamps with: (repository allHashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:12'!
handleGetMemos: message
	^ MDMemos with: (repository memos)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:26'!
handleGoodbye: message
	^ MDGoodbye new! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:08'!
handleHello: message
	^ MDHello new! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/4/2008 22:43'!
handleMessage: aMessage
	^ [aMessage handledBy: self]
		on: Error
		do: [:err | MDProcessingError with: err description]! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:21'!
handleOfferObjects: message
	| wanted |
	wanted _ repository selectFrom: message hashstamps.
	^ MDRequestObjects with: wanted! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:34'!
handlePutObjects: message

	^ 	[repository putAll: message objects.
		MDThankYou with: message objects size]
			on: Error
			do: [:err | MDStorageFailed with: err description]! !

!MDNetService methodsFor: 'initialize-release' stamp: 'cwp 1/4/2008 21:23'!
setRepository: aRepository
	repository _ aRepository! !

Object subclass: #MDServerLink
	instanceVariableNames: 'stream service process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDServerLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:15'!
serve: aSocket repository: aRepository
	| link |
	link _ self socket: aSocket repository: aRepository.
	link start! !

!MDServerLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:16'!
socket: aSocket repository: aRepository
	^ self new setSocket: aSocket repository: aRepository! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 17:11'!
handleMessage
	|  request response |
	[request _ MDNetMessage readFrom: stream]
		on: ConnectionClosed, ConnectionTimedOut 
		do: [:exception | ^ nil].
	response _ service handleMessage: request.
	response writeOn: stream.
	stream flush.
	response isGoodbye ifTrue: [stream close]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:32'!
name
	^ String streamContents:
		[:out |
		out 
			nextPutAll: stream socket remoteAddress asString;
			nextPutAll: '->';
			nextPutAll: service description]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:16'!
run
	[stream isConnected] whileTrue: [self handleMessage]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 17:02'!
setSocket: aSocket repository: aRepository
	stream _ self streamClass on: aSocket.
	service _ MDNetService for: aRepository.
	stream binary! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:19'!
start
	process _ [self run] 
				forkAt: Processor highIOPriority 
				named: self name
! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:18'!
streamClass
	^ Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream]! !

TestCase subclass: #MDByteIndexTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 04:01'!
storeAndRetrieveWithFileSize: aNumber
	|  file stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	stream next: aNumber put: 0.
	stream reset.
 
	file _ MDByteIndex stream: stream keySize: 2 valueSize: 4.
	file at: 'aa' asByteArray put: 'abcd' asByteArray.
	file at: 'ab' asByteArray put: 'qxry' asByteArray.
	file at: 'xy' asByteArray put: '1234' asByteArray.
	self assert: file tally = 3.

	self assert: (file at: 'aa' asByteArray) = 'abcd' asByteArray.
	self assert: (file at: 'ab' asByteArray) = 'qxry' asByteArray.
	self assert: (file at: 'xy' asByteArray) = '1234' asByteArray.
	file at: 'ab' asByteArray put: '9876' asByteArray.
	self assert: (file at: 'ab' asByteArray) = '9876' asByteArray.
	self assert: file tally = 3! !

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 03:58'!
testStoreAndRetrieve
	self storeAndRetrieveWithFileSize: 100.
	self storeAndRetrieveWithFileSize: 24.
	self should: [self storeAndRetrieveWithFileSize: 12] raise: Error! !

TestCase subclass: #MDChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:31'!
isAbstract
	^ self name = #MDChunkTest! !

!MDChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 23:11'!
write: aChunk
	| stream |
	stream _ WriteStream on: String new.
	aChunk writeOn: stream.
	^ stream contents.
! !

MDChunkTest subclass: #MDClassChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:04'!
testDefinitionA
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:05'!
testDefinitionB
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusB).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'Object subclass: #BogusB
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:07'!
testDefinitionBytes
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #bytes;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'Object variableByteSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:12'!
testDefinitionCategory
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Griffle';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Griffle''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:13'!
testDefinitionSuperclass
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #String;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'String subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:08'!
testDefinitionVariable
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #variable;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'Object variableSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:11'!
testDefinitionWeak
	| chunk properties result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties _ MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #weak;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result _ self write: chunk.
	self assert: result = 'Object weakSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:41'!
testDefinitionWords
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #words;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableWordSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 00:19'!
testRemoval
	| chunk result |
	chunk _ MDClassChunk forElement: (MDClassElement className: #BogusA).
	chunk remove.
	result _ self write: chunk.
	self assert: result = 'Smalltalk removeClassNamed: #BogusA!!
'! !

MDChunkTest subclass: #MDClassCommentChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:43'!
testClassIsRemoved
	| chunk actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusA).
	class remove.
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	chunk load: MDPropertyDictionary new.
	chunk reactToClass: class.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:03'!
testDefinitionWithBang
	| chunk properties actual |
	chunk _ MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	properties _ MDPropertyDictionary new
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					text: 'Comment!! for BogusA'
					yourself.
	chunk load: properties.
	actual _ self write: chunk.
	self assert: actual =  '!!BogusA commentStamp: ''cwp 3/28/2008 23:18'' prior: 0!!
Comment!!!! for BogusA!!
'! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 23:27'!
testDefinitionWithStamp
	| chunk properties actual |
	chunk _ MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	properties _ MDPropertyDictionary new
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					text: 'Comment for BogusA'
					yourself.
	chunk load: properties.
	actual _ self write: chunk.
	self assert: actual =  '!!BogusA commentStamp: ''cwp 3/28/2008 23:18'' prior: 0!!
Comment for BogusA!!
'! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 23:35'!
testRemoval
	| chunk actual |
	chunk _ MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	chunk remove.
	actual _ self write: chunk.
	self assert: actual =  '!!BogusA classComment: nil stamp: nil!!
'! !

MDChunkTest subclass: #MDMemoChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:44'!
testDescription
	| memo chunk actual expected  |
	memo := MDBogusRepositoryResource new setUp repository memos anyOne.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	expected := '"', memo name, String cr, memo description, '"!!', String cr.
	self assert: actual = expected! !

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:52'!
testDescriptionWithBang
	| memo chunk actual  |
	memo := (MDBogusRepositoryResource new setUp repository memos anyOne) copy.
	memo properties description: 'This contains a !! inside it'.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	self assert: (actual includesSubString: '!!!!')! !

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:52'!
testDescriptionWithDoubleQuote
	| memo chunk actual  |
	memo := (MDBogusRepositoryResource new setUp repository memos anyOne) copy.
	memo properties description: 'This contains a "quoted" phrase'.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	self assert: (actual includesSubString: '""')! !

MDChunkTest subclass: #MDMethodChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:57'!
methodA
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #a
			classIsMeta: true)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:59'!
methodAExpected
	^ '!!BogusA class methodsFor: ''capitals'' stamp: ''cwp 3/28/2008 23:18''!!
a
	^ $A!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:01'!
methodAExpected2
	^ '!!BogusA class methodsFor: ''capitals''!!
a
	^ $A!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:02'!
methodAExpected3
	^ 'BogusA class removeSelector: #a!!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 23:37'!
methodOne
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #one)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:22'!
methodOneExpected
	^ '!!BogusA methodsFor: ''numbers'' stamp: ''cwp 3/28/2008 23:18''!!
one
	^ self!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:22'!
methodOneExpected2
	^ '!!BogusA methodsFor: ''numbers''!!
one
	^ self!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 00:59'!
methodOneExpected3
	^ 'BogusA removeSelector: #one!!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:58'!
testClassDefinitionWithStamp
	| chunk properties actual expected |
	chunk _ self methodA.
	properties _ MDPropertyDictionary new
					category: #capitals;
					initials: 'cwp';
					timestamp: (MDTimestamp fromInteger: 886029518);
					source: ('a', String cr, '	^ $A');
					yourself.
	chunk load: properties.
	actual _ self write: chunk.
	expected _ self methodAExpected.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:01'!
testClassDefinitionWithoutStamp
	| chunk properties actual expected |
	chunk _ self methodA.
	properties _ MDPropertyDictionary new
					category: #capitals;
					source: ('a', String cr, '	^ $A');
					yourself.
	chunk load: properties.
	actual _ self write: chunk.
	expected _ self methodAExpected2.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/26/2008 20:41'!
testClassIsRemoved
	| chunk actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusA).
	class remove.
	chunk := self methodA.
	chunk remove.
	chunk reactToClass: class.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:02'!
testClassRemoval
	| chunk actual expected |
	chunk _ self methodA.
	chunk remove.
	actual _ self write: chunk.
	expected _ self methodAExpected3.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:07'!
testDefinitionWithBang
	| chunk properties actual |
	chunk _ self methodOne.
	properties _ MDPropertyDictionary new
					category: #numbers;
					initials: 'cwp';
					timestamp: (MDTimestamp fromInteger: 886029518);
					source: ('one', String cr, '	^ ''Sha!!bang''');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: (actual includesSubString: '!!!!')! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 00:47'!
testDefinitionWithStamp
	| chunk properties actual expected |
	chunk _ self methodOne.
	properties _ MDPropertyDictionary new
					category: #numbers;
					initials: 'cwp';
					timestamp: (MDTimestamp fromInteger: 886029518);
					source: ('one', String cr, '	^ self');
					yourself.
	chunk load: properties.
	actual _ self write: chunk.
	expected _ self methodOneExpected.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 00:48'!
testDefinitionWithoutStamp
	| chunk properties actual expected |
	chunk _ self methodOne.
	properties _ MDPropertyDictionary new
					category: #numbers;
					source: ('one', String cr, '	^ self');
					yourself.
	chunk load: properties.
	actual _ self write: chunk.
	expected _ self methodOneExpected2.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/26/2008 20:03'!
testRemoval
	| chunk actual expected |
	chunk := self methodOne.
	chunk remove.
	actual := self write: chunk.
	expected := self methodOneExpected3.
	self assert: actual = expected.! !

MDChunkTest subclass: #MDVariableChunkTest
	instanceVariableNames: 'chunk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

MDVariableChunkTest subclass: #MDClassInstVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:30'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''first'') ifFalse:
		[BogusB class addInstVarName: ''first'']]!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:36'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''first'') ifTrue:
		[BogusB class removeInstVarName: ''first'']]!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:28'!
expectedSimpleDefinition
	^ '(BogusB class instVarNames includes: ''first'') ifFalse:
	[BogusB class addInstVarName: ''first'']!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:36'!
expectedSimpleRemoval
	^ '(BogusB class instVarNames includes: ''first'') ifTrue:
	[BogusB class removeInstVarName: ''first'']!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:13'!
setUp
	chunk := MDClassInstVarChunk forElement: 
				(MDClassInstVarElement className: #BogusB name: #first)! !

MDVariableChunkTest subclass: #MDClassVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 22:23'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''First'') ifFalse:
		[BogusB addClassVarName: ''First'']]!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:23'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''First'') ifTrue:
		[BogusB removeClassVarName: ''First'']]!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 22:55'!
expectedSimpleDefinition
	^ '(BogusB classVarNames includes: ''First'') ifFalse:
	[BogusB addClassVarName: ''First'']!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:22'!
expectedSimpleRemoval
	^ '(BogusB classVarNames includes: ''First'') ifTrue:
	[BogusB removeClassVarName: ''First'']!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:13'!
setUp
	chunk := MDClassVarChunk forElement: 
				(MDClassVarElement className: #BogusB name: #First)! !

MDVariableChunkTest subclass: #MDInstVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:40'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''first'') ifFalse:
		[BogusB addInstVarName: ''first'']]!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:38'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''first'') ifTrue:
		[BogusB removeInstVarName: ''first'']]!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:41'!
expectedSimpleDefinition
	^ '(BogusB instVarNames includes: ''first'') ifFalse:
	[BogusB addInstVarName: ''first'']!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:31'!
expectedSimpleRemoval
	^ '(BogusB instVarNames includes: ''first'') ifTrue:
	[BogusB removeInstVarName: ''first'']!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:15'!
setUp
	chunk := MDInstVarChunk forElement: (MDInstVarElement 
			className: #BogusB
			name: #first)! !

MDVariableChunkTest subclass: #MDPoolImportChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:45'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifFalse:
		[BogusB addSharedPool: BogusPool]]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:29'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifTrue:
		[BogusB removeSharedPool: BogusPool]]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:27'!
expectedSimpleDefinition
	^ '(BogusB sharedPools includes: BogusPool) ifFalse:
	[BogusB addSharedPool: BogusPool]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:29'!
expectedSimpleRemoval
	^ '(BogusB sharedPools includes: BogusPool) ifTrue:
	[BogusB removeSharedPool: BogusPool]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:18'!
setUp
	chunk := MDPoolImportChunk forElement: (MDPoolImportElement 
			className: #BogusB
			name: #BogusPool)! !

!MDVariableChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:30'!
isAbstract
	^ self name = #MDVariableChunkTest! !

!MDVariableChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:30'!
shouldInheritSelectors
	^ true! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:38'!
testClassIsRemoved
	| actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusB).
	class remove.
	chunk reactToClass: class.
	chunk load: MDPropertyDictionary new.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testIndependentDefinition
	| actual expected |
	chunk load: MDPropertyDictionary new.
	actual := self write: chunk.
	expected := self expectedIndependentDefinition.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testIndependentRemoval
	| actual expected |
	chunk remove.
	actual := self write: chunk.
	expected := self expectedIndependentRemoval.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testSimpleDefinition
	| actual expected |
	chunk load: MDPropertyDictionary new.
	chunk beDependent.
	actual := self write: chunk.
	expected := self expectedSimpleDefinition.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:21'!
testSimpleRemoval
	| actual expected |
	chunk remove.
	chunk beDependent.
	actual := self write: chunk.
	expected := self expectedSimpleRemoval.
	self assert: actual = expected! !

TestCase subclass: #MDFileOutExporterTest
	instanceVariableNames: 'stream exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFileOutExporterTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
resources
	^ {MDBogusRepositoryResource}! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 22:34'!
get: aString
	^ self repository get: (MDHashstamp fromString: aString).! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:18'!
repository
	^ MDBogusRepositoryResource current repository! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:20'!
setUp
	stream := WriteStream on: String new.
	exporter := MDFileOutExporter on: stream.! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:07'!
testClassA
	| version actual |
	version _ self get: 'BB7B1j1C3yfXYwfk5gtjhSCFfn2bLTAs'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusA' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:07'!
testClassAComment
	| version actual |
	version _ self get: 'BB7B1tna4jGwDgeSxlbbDkUcSLErTdOk'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusA' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:10'!
testClassBClassInstVar
	| version actual |
	version _ self get: 'BB7B1zTQEHxvWFPEsVxbHwWnsGpZ8-F8'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusB class' caseSensitive: true).
	self assert: (actual includesSubstring: 'addInstVarName:' caseSensitive: true).
	self assert: (actual includesSubstring: 'firstClassInstanceVariableB' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:11'!
testClassBClassMethod
	| version actual |
	version _ self get: 'BB7B1nKluvicTh-w4Xdifl4d7kuWIHED'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusA class' caseSensitive: true).
	self assert: (actual includesSubstring: 'isCompletelyUseless' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:13'!
testClassBClassVar
	| version actual |
	version := self get: 'BB7B1ruO0oxpSMVzlLfCBquosWpdeYnJ'.
	actual := self write: version.
	self assert: (actual includesSubstring: 'BogusB' caseSensitive: true).
	self assert: (actual includesSubstring: 'addClassVarName:' caseSensitive: true).
	self assert: (actual includesSubstring: 'FirstClassVariableB' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:16'!
testClassBInstVar
	| version actual |
	version _ self get: 'BB7B1nM4Kemmzcp8lG0EnAWfLbbIM+He'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusB' caseSensitive: true).
	self assert: (actual includesSubstring: 'firstInstanceVariableB' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:17'!
testClassBMethod
	| version actual |
	version _ self get: 'BB7B1yzW5XouALdQoDzYT5kR7B952TFR'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusB' caseSensitive: true).
	self assert: (actual includesSubstring: 'foo' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 19:18'!
testClassBPoolImport
	| version actual |
	version _ self get: 'BB7B1mWoSKTpGSE50pVKPvCQNLWkTnCU'.
	actual _ self write: version.
	self assert: (actual includesSubstring: 'BogusB' caseSensitive: true).
	self assert: (actual includesSubstring: 'BogusPool' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 22:02'!
testCompleteSnapshot
	| memo |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	self assert: stream contents size > 3000.! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 22:05'!
testDependenciesHonored
	| memo fileout |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	self deny: (fileout includesSubString: 'Smalltalk hasClassNamed:')! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 00:05'!
write: aVersion
	exporter add: aVersion.
	exporter flush.
	^ stream contents! !

TestCase subclass: #MDKeyedStreamTest
	instanceVariableNames: 'dataStream baseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:24'!
append: aSmallInteger
	dataStream 
		appendKey: (self key: aSmallInteger)
		value: (self value: aSmallInteger).
! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:19'!
assert: bytes is: aSmallInteger
	self assert: bytes last = aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
bytes: count containing: aSmallInteger
	| key |
	key _ ByteArray new: count.
	key at: key size put: aSmallInteger.
	^ key! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
key: aSmallInteger
	^ self bytes: dataStream keySize containing: aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'running' stamp: 'avi 4/17/2005 01:19'!
setUp
	baseStream := RWBinaryOrTextStream on: (ByteArray new: 100).
	dataStream := MDKeyedStream on: baseStream! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:11'!
testAppend
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: 1.
		self assert: v is: 1.
		self assert: p >= 0]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:18'!
testKeysValuePositions
	| index position |
	1 to: 3 do: [:i | self append: i].
	index _ 1.
	position _ -1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: index.
		self assert: v is: index.
		self assert: p > position.
		position _ p.
		index _ index + 1]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'avi 4/17/2005 01:39'!
testPosition
	| position |
	position _ dataStream nextValuePosition.
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | self assert: p = position].
! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 17:17'!
testValueAtPosition
	| position |
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | position _ p].
	self assert: (dataStream valueAtPosition: position) is: 1! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:07'!
value: aSmallInteger
	^ self bytes: dataStream keySize * 2 containing: aSmallInteger! !

TestCase subclass: #MDNetLocatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:33'!
testDefaultPort
	| locator |
	locator _ MDNetLocator host: 'source.wiresong.ca'.
	self assert: locator port = 6101! !

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:29'!
testDescription
	| locator |
	locator _ MDNetLocator host: 'source.wiresong.ca' port: 6101.
	self assert: locator description = 'source.wiresong.ca:6101'! !

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:31'!
testDescriptionWithoutPort
	| locator |
	locator _ MDNetLocator host: 'source.wiresong.ca'.
	self assert: locator description = 'source.wiresong.ca'! !

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:33'!
testHost
	| locator |
	locator _ MDNetLocator host: 'source.wiresong.ca'.
	self assert: locator host = 'source.wiresong.ca'! !

MDTestCase subclass: #MDNetClientTest
	instanceVariableNames: 'link repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:23'!
setUp
	link _ MDMockLink new.
	repository _ MDNetRepository link: link! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:15'!
testClose
	link
		open;
		expect: (MDGoodbye new);
		inject: (MDGoodbye new).
	repository close.
	self deny: link isOpen! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:51'!
testCloseProtocolError
	
	link
		open;
		expect: (MDGoodbye new);
		inject: (MDHello new).
	
	self
		should: [repository close]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:20'!
testDescription
	self assert: repository description = 'Mock'! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:44'!
testGet
	| version result |
	version _ self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	result _ repository get: version hashstamp.
	self assert: result = version.
! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:44'!
testGetAll
	| version result |
	version _ self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	result _ repository getAll: {version hashstamp}.
	self assert: result anyOne = version.
! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 13:08'!
testGetAllNotFound
	| version result |
	version _ self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: #()).
	result _ repository getAll: {version hashstamp}.
	self assert: result isEmpty! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:51'!
testGetAllProtocolError
	| version |
	version _ self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDGoodbye new).
	
	self
		should: [repository getAll: {version hashstamp}]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 13:07'!
testGetNotFound
	| version result |
	version _ self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: #()).
	result _ repository get: version hashstamp.
	self assert: result isNil! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:55'!
testGetProtocolError
	
	| hashstamp |
	hashstamp _ self version hashstamp.
	link
		open;
		expect: (MDGetObjects with: {hashstamp});
		inject: (MDGoodbye new).
	
	self
		should: [repository get: hashstamp]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:40'!
testGetSome
	| a b result |
	a _ self versionWith: #a.
	b _ self versionWith: #b.
	link
		open;
		expect: (MDGetObjects with: {a hashstamp. b hashstamp});
		inject: (MDObjects with: {a}).
	result _ repository getAll: {a hashstamp. b hashstamp}.
	self assert: result size = 1.
	self assert: result anyOne = a! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:38'!
testHashstamps
	| memo result |
	memo _ self memo.
	link
		open;
		expect: (MDGetHashstamps new);
		inject: (MDAllHashstamps with: {memo}).
	result _ repository allHashstamps.
	self assert: result size = 1.
	self assert: result anyOne = memo! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:52'!
testHelloProtocolError
	
	link
		expect: (MDHello new);
		inject: (MDGoodbye new).
	
	self
		should: [repository memos]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 13:03'!
testImplicitOpen
	| version |
	version _ self version.
	link
		expect: MDHello new;
		inject: MDHello new;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	repository get: version hashstamp.! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:46'!
testImplicitReopen
	| version |
	version _ self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	repository get: version hashstamp.
	link 
		close;
		expect: MDHello new;
		inject: MDHello new;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	repository get: version hashstamp.! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:23'!
testMemos
	| memo result |
	memo _ self memo.
	link
		open;
		expect: (MDGetMemos new);
		inject: (MDMemos with: {memo}).
	result _ repository memos.
	self assert: result size = 1.
	self assert: result anyOne = memo! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:50'!
testMemosProtocolError
	
	link
		open;
		expect: (MDGetMemos new);
		inject: (MDHello new).
	
	self
		should: [repository memos]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:02'!
testPut
	| version |
	version _ self version.
	link
		open;
		expect: (MDPutObjects with: {version});
		inject: (MDThankYou with: 1).
	repository put: version.
	! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:12'!
testPutAll
	| version |
	version _ self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDRequestObjects with: {version hashstamp});
		expect: (MDPutObjects with: {version});
		inject: (MDThankYou with: 1).
	repository putAll: {version}.
	! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:05'!
testPutAllFailed
	| version |
	version _ self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDRequestObjects with: {version hashstamp});
		expect: (MDPutObjects with: {version});
		inject: (MDStorageFailed with: 'Just testing').
	self 
		should: [repository putAll: {version}]
		raise: MDPeerError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:00'!
testPutAllProtocolError1
	| version |
	version _ self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDThankYou new).
	self
		should: [repository putAll: {version}]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:02'!
testPutAllProtocolError2
	| version |
	version _ self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDRequestObjects with: {version hashstamp});
		expect: (MDPutObjects with: {version});
		inject: (MDHello new).
	self
		should: [repository putAll: {version}]
		raise: MDProtocolError
	! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:50'!
testPutFailed
	| version |
	version _ self version.
	link
		open;
		expect: (MDPutObjects with: {version});
		inject: (MDStorageFailed with: 'Just testing').
	
	self
		should: [repository put: version]
		raise: MDPeerError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:29'!
testPutNone
	| a b |
	a _ self versionWith: #a.
	b _ self versionWith: #b.
	link
		open;
		expect: (MDOfferObjects with: {a hashstamp. b hashstamp});
		inject: (MDRequestObjects with: #()).
	repository putAll: {a. b}.
	link
		close
		expect: (MDGoodbye new);
		inject: (MDGoodbye new).
	repository close! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 20:56'!
testPutProtocolError
	| version |
	version _ self version.
	link
		open;
		expect: (MDPutObjects with: {self version});
		inject: (MDHello new).
	
	self 
		should: [repository put: version]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:26'!
testPutSome
	| a b |
	a _ self versionWith: #a.
	b _ self versionWith: #b.
	link
		open;
		expect: (MDOfferObjects with: {a hashstamp. b hashstamp});
		inject: (MDRequestObjects with: {a hashstamp});
		expect: (MDPutObjects with: {a});
		inject: (MDThankYou with: 1).
	repository putAll: {a. b}.
	! !

!MDNetClientTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:51'!
testSelectFrom
	| hashstamp result |
	hashstamp _ self version hashstamp.
	link
		open;
		expect: (MDOfferObjects with: {hashstamp});
		inject: (MDRequestObjects with: {hashstamp}).
		
	result _ repository selectFrom: {hashstamp} asSet.
	self assert: result size = 1.
	self assert: result anyOne = hashstamp! !

MDTestCase subclass: #MDNetLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:01'!
testClose
	| link |
	link _ MDNetLink locator: (MDFakeLocator new).
	link open.
	link locator mocket 
		execute: [link close];
		expectClose;
		done.! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:03'!
testDescription
	| link |
	link _ MDNetLink locator: (MDFakeLocator new).
	self assert: link description = 'Fake'! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 16:04'!
testOpen
	| link |
	link _ MDNetLink locator: (MDFakeLocator new).
	link open.
	self assert: link isOpen.
	self assert: link locator mocket isConnected.! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:22'!
testSend
	| link mocket msg |
	link _ MDNetLink locator: (MDFakeLocator new).
	mocket _ link locator mocket.
	msg _ MDHello with: 'test'.
	mocket
		execute: [link open; send: msg];
		expect: msg bytes;
		done! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:23'!
testSendBeforeOpen
	| link msg |
	link _ MDNetLink locator: (MDFakeLocator new).
	msg _ MDHello with: 'test'.
	self 
		should: [link send: msg]
		raise: Error! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:59'!
testSendResponse
	| link mocket msg result |
	link _ MDNetLink locator: (MDFakeLocator new).
	mocket _ link locator mocket.
	msg _ MDHello with: 'test'.
	mocket
		execute: 
			[link open.
			result _ link send: msg.
			self assert: result class = MDHello];
		expect: msg bytes;
		inject: msg bytes! !

MDTestCase subclass: #MDNetSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetSerializationTest methodsFor: 'asserting' stamp: 'cwp 1/3/2008 23:04'!
assertEqualityOf: anObject
	| bytes other |
	bytes _ anObject bytes.
	other _ MDNetMessage fromBytes: bytes.
	self assert: anObject = other! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:30'!
testAuthenticationFailed
	self assertEqualityOf: (MDAuthenticationFailed with: 'Unknown user')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/8/2008 18:38'!
testGetHashstamps
	self assertEqualityOf: MDGetHashstamps new! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/3/2008 23:32'!
testGetMemos
	self assertEqualityOf: MDGetMemos new! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/3/2008 23:25'!
testGetObjects
	self assertEqualityOf: (MDGetObjects with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:40'!
testGoodbye
	self assertEqualityOf: (MDGoodbye with: 'colin@wiresong.ca')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/8/2008 18:17'!
testHashstamps
	self assertEqualityOf: (MDAllHashstamps with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:37'!
testHello
	self assertEqualityOf: (MDHello with: 'colin@wiresong.ca')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:18'!
testIdConflict
	| messages others |
	messages _ MDNetMessage allSubclasses select: [:ea | ea isConcrete].
	messages do:
		[:msg |
		others _ messages copyWithout: msg.
		others do: [:other | self deny: msg id = other id]]! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:09'!
testMemos
	self assertEqualityOf: (MDMemos with: (Set with: self memo))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:34'!
testObjectNotFound
	self assertEqualityOf: (MDStorageFailed with: 'Disk full')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:08'!
testObjects
	self assertEqualityOf: (MDObjects with: (Set with: self version))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:23'!
testOfferObjects
	self assertEqualityOf: (MDOfferObjects with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:07'!
testPutObjects
	self assertEqualityOf: (MDPutObjects with: (Set with: self version))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:23'!
testRequestObjects
	self assertEqualityOf: (MDRequestObjects with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/3/2008 23:53'!
testThankYou
	self assertEqualityOf: (MDThankYou with: 4)! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:31'!
testUnauthorized
	self assertEqualityOf: (MDUnauthorized with: 'That version is private')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:26'!
testUnrecognizedMessage
	self assertEqualityOf: (MDUnrecognizedMessage with: 'Message id 555 not implemented')! !

MDTestCase subclass: #MDNetServiceTest
	instanceVariableNames: 'service repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:22'!
setUp
	repository _ MDMemoryRepository new.
	service _ MDNetService for: repository.! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:22'!
testGetMemos
	| memo result |
	memo _ self memo.
	repository put: memo.
	result _ service handleMessage: (MDGetMemos new).
	self assert: result isMemos.
	self assert: (result objects includes: memo)! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:05'!
testGetNotFound
	| a b result |
	a _ self versionWith: #a.
	b _ self versionWith: #b.
	repository put: b.
	result _ service handleMessage: (MDGetObjects with: {a hashstamp. b hashstamp}).
	self assert: result isObjects.
	self assert: result objects size = 1.
	self assert: result objects anyOne = b.! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:03'!
testGetObjects
	| version result |
	version _ self version.
	repository put: version.
	result _ service handleMessage: (MDGetObjects with: {version hashstamp}).
	self assert: result isObjects.
	self assert: (result objects includes: version)! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:06'!
testGetPartial
	| version result |
	version _ self version.
	result _ service handleMessage: (MDGetObjects with: {version hashstamp}).
	self assert: result isObjects.
	self assert: result objects isEmpty! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:24'!
testGoodbye
	| result |
	result _ service handleMessage: MDGoodbye new.
	self assert: result isGoodbye! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:07'!
testHello
	
	| result |
	result _ service handleMessage: MDHello new.
	self assert: result isHello.
! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:29'!
testOfferObjects
	| result a b |
	a _ self versionWith: #a.
	b _ self versionWith: #b.
	repository put: a.
	result _ service handleMessage: (MDOfferObjects with: {a hashstamp. b hashstamp}).
	self assert: result isRequestObjects.
	self assert: result hashstamps size = 1.
	self assert: result hashstamps anyOne = b hashstamp.! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:27'!
testOfferObjectsUnneeded
	| result version |
	version _ self version.
	repository put: version.
	result _ service handleMessage: (MDOfferObjects with: {version hashstamp}).
	self assert: result isRequestObjects.
	self assert: result hashstamps isEmpty! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:14'!
testPutObjects
	| version result |
	version _ self version.
	result _ service handleMessage: (MDPutObjects with: {version}).
	self assert: result isThankYou.
	self assert: (repository get: version hashstamp) = version! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:35'!
testPutObjectsFailed
	| version result |
	version _ self version.
	service instVarNamed: 'repository' put: nil.
	result _ service handleMessage: (MDPutObjects with: {version}).
	self assert: result class = MDStorageFailed.
	self assert: result description = 'MessageNotUnderstood: UndefinedObject>>putAll:'! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 22:43'!
testServerError
	| version result |
	version _ self version.
	service instVarNamed: 'repository' put: nil.
	result _ service handleMessage: (MDGetObjects with: {version hashstamp}).
	self assert: result class = MDProcessingError.
	self assert: result description = 'MessageNotUnderstood: UndefinedObject>>getAll:'! !

MDRepository subclass: #MDFileRepository
	instanceVariableNames: 'dataStream index memos lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 10/12/2005 21:30'!
extension
	^ '.mcr'! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 2/2/2006 22:20'!
named: aString
	^ self on: (FileStream fileNamed: aString, self extension)! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 7/19/2007 10:41'!
named: aString do: aBlock
	^ self
		on: (FileStream fileNamed: aString, self extension)
		do: aBlock! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 06:50'!
on: aFileStream
	^ self new
		initializeWithStream: aFileStream;
		yourself! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 7/19/2007 10:41'!
on: aFileStream do: aBlock
	|repos|
	repos := self new
				initializeWithStream: aFileStream;
				yourself.
	^ [aBlock value: repos]
		ensure: [repos close]! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:22'!
= other
	^ self species = other species
		and: [other dataStreamIs: dataStream]! !

!MDFileRepository methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:11'!
allHashstamps
	self rescanData.
	^ index keys collect: [:ea | MDHashstamp fromBytes: ea]! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 10/13/2005 23:01'!
close
	dataStream close! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 12/25/2006 15:23'!
dataStreamIs: aStream
	^ dataStream = aStream! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 3/20/2006 00:13'!
description
	^ dataStream stream localName! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/19/2005 01:50'!
get: aHashstamp 
	| key bytes position |
	key := aHashstamp bytes.
	position := index at: key ifAbsent: [^self rescanData ifTrue: [self get: aHashstamp]].
	bytes := dataStream valueAtPosition: position.
	^MDMarshal materialize: bytes! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ dataStream hash! !

!MDFileRepository methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:12'!
includes: aHashstamp
	self rescanData.
	^ index includesKey: aHashstamp bytes! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 06:48'!
initializeWithStream: aFileStream
	dataStream := MDKeyedStream on: aFileStream.
	lastPosition := 0.
	index := Dictionary new.
	memos := Set new.
	self rescanData! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 1/19/2007 20:57'!
memos
	
	self rescanData.
	^ memos! !

!MDFileRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:18'!
put: aHashedObject
	| key value |
	key := aHashedObject hashstamp bytes.
	index at: key ifAbsent:
		[value := MDMarshal serialize: aHashedObject.
		index at: key put: dataStream nextValuePosition.
		dataStream appendKey: key value: value.
		dataStream flush]! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 3/3/2008 20:12'!
rescanData
	dataStream reopen.
	dataStream fromPosition: lastPosition keysValuesAndPositionsDo:  
		[:key :val :pos |
		index at: key put: pos.
		(MDMarshal isMemo:val) ifTrue:
			[memos add: (MDMarshal materialize: val)]].
	dataStream position = lastPosition
		ifTrue: [^ false]
		ifFalse: [lastPosition _ dataStream position. ^ true]! !

MDRepository subclass: #MDNetRepository
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self link: (MDNetLink host: aString)! !

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:27'!
host: aString port: anInteger
	^ self link: (MDNetLink host: aString port: anInteger)! !

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:23'!
link: aLink
	^ self new setLink: aLink! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 1/8/2008 18:40'!
allHashstamps
	| result |
	result _ self send: MDGetHashstamps new.
	result assertMessageIs: MDAllHashstamps.
	^ result hashstamps! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 21:06'!
close
	| bye |
	bye _ link send: MDGoodbye new.
	link close.
	bye assertMessageIs: MDGoodbye! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 14:20'!
description
	^ link description! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 13:08'!
get: aHashstamp
	| objects |
	objects _ self getAll: (Set with: aHashstamp).
	^ objects isEmpty ifFalse: [objects anyOne]! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 21:08'!
getAll: aCollection
	| result |
	result _ self send: (MDGetObjects with: aCollection).
	result assertMessageIs: MDObjects.
	^ result objects! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 1/8/2008 18:45'!
includes: aHashstamp
	^ (self get: aHashstamp) notNil! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 1/21/2008 20:41'!
locator
	^ link locator! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 21:08'!
memos
	| result |
	result _ self send: MDGetMemos new.
	result assertMessageIs: MDMemos.
	^ result objects! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 21:07'!
put: anObject
	| result |
	result _ self send: (MDPutObjects with: {anObject}). 
	result assertMessageIs: MDThankYou! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/4/2008 21:09'!
putAll: aCollection
	| request |
	request _ self send: (MDOfferObjects withObjects: aCollection).
	request assertMessageIs: MDRequestObjects.
	request 
		filter: aCollection
		in: [:put | (self send: put) assertMessageIs: MDThankYou]
! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 1/8/2008 18:52'!
selectFrom: aCollection
	| request |
	request _ self send: (MDOfferObjects with: aCollection).
	request assertMessageIs: MDRequestObjects.
	^ request hashstamps! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 1/4/2008 21:07'!
send: aMessage
	| result |
	link isOpen ifFalse:
		[link open.
		result _ link send: MDHello new.
		result assertMessageIs: MDHello].
	result _ link send: aMessage.
	result checkForError.
	^ result! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 1/4/2008 12:23'!
setLink: aLink
	link _ aLink! !

Error subclass: #MDNetError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDNetError subclass: #MDPeerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDNetError subclass: #MDProtocolError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!
